package hay.component;

public class HayInitalSearch {

	private final char HANGUL_BEGIN_UNICODE = 44032; // 
	private final char HANGUL_END_UNICODE = 55203; // R
	private final char HANGUL_BASE_UNIT = 588;//   ڼ

	private final String[] INITIAL_SOUND = { "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "" };


	/**
	 * ʼ . (  ->  ,  - >  ) 
	 * @param hanChar 
	 * @return ʼ ٲ 
	 */
	private String getInitalSound(char hanChar) {
		// -  44032  588   0 ´.
		// -  44032  588   1 ´.
		int hanBegin = (hanChar - HANGUL_BEGIN_UNICODE);
		int index = hanBegin / HANGUL_BASE_UNIT;
		return INITIAL_SOUND[index];
	}

	/**
	 *  ΰ?
	 * @param unicode ѹ
	 * @return  ڶ true
	 */
	private boolean isHangul(char unicode) {
		return HANGUL_BEGIN_UNICODE <= unicode && unicode <= HANGUL_END_UNICODE;
	}

	/**
	 * ش ڰ ʼ ˻Ѵ.
	 * @param c ˻ϴ 
	 * @return ʼ̶ ture
	 */
	private boolean containInitialChar(String c) {
		for( int i = 0 ; i< INITIAL_SOUND.length ; i++){
			if(INITIAL_SOUND[i].equals(c)){
				return true;
			}
		}
		return false;
	}

	/**
	 * value search   ֵ ʿ信  ʼ ٲ۴. 
	 * @param value ˻ ϴ 
	 * @param search ˻ϴ .
	 * @return search  value ʼ ٲ String
	 */
	private String getHangulInitialSound(String value, String search) {
		StringBuilder sb = new StringBuilder();
		int minLen = Math.min(value.length(), search.length());
		for (int i=0; i<minLen; i++) {
			
			// ּҷ ڸ ٲ̴ܰ.
			char ch = value.charAt(i);
			
			//˻ϴ ڰ ʼ̰ &&  ּҷ ڰ  ʼ ƴ϶
			if ( containInitialChar(search.substring(i,i+1)) && isHangul(ch) ) {
				//ּҷ ʼ ƴϰ ˻ϴ ʼϰ. ּҷϹڸ ʼ Ѵ.
				sb.append(getInitalSound(ch));
			}else{
				//   ׳  ״ Ѵ.
				sb.append(ch);
			}
		}
		return sb.toString();
	}

	/**
	 * 
	 * @param value ̸
	 * @param search ˻ҹ
	 * @return ġѴٸ true
	 */
	public boolean isHangulInitialSound(String value, String search) {
		//߿ ϳ null̶
		if(value == null || search == null){
			//ּҷϰ null ƴ϶ true
			if(value != null) return true;
			//
			return search == value;
		}
		
		return search.equals(getHangulInitialSound(value, search));
	}
}