package hay.tab;

import java.util.ArrayList;
import hay.app.HayDetail;
import hay.app.HaySmsDetail;
import hay.app.R;
import hay.component.HayCallLog;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.database.HayDatabase;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class ListFew extends ListActivity {

	private ArrayList<HayCallLog> cateList;
	private ListAdapter cAdapter;
	private HayDatabase mDbHelper = new HayDatabase(this);

	private String[] selectNumber;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.sort_list);

		cateList = new ArrayList<HayCallLog>();
		cAdapter = new ListAdapter(cateList);
		setListAdapter(cAdapter);
	}

	protected void onResume() {
		super.onResume();
		cateList.clear();
		mDbHelper.open();
		addDatabase();
		cAdapter.notifyDataSetChanged();
		mDbHelper.close();
	}

	private void addDatabase() {

		Cursor cursor = mDbHelper.fetchAddtion(false);
		startManagingCursor(cursor);
		while(cursor.moveToNext()) {

			HayCallLog call_log = new HayCallLog();

			int contact_id = cursor.getInt(0);
			int score = cursor.getInt(1);

			//̵ 
			call_log.setContact_id(contact_id);
			call_log.setScore(score);
			call_log.setName("");
			cateList.add(call_log);
		}
	}

	protected void onListItemClick(ListView l, View v, final int position,long id) {
		super.onListItemClick(l, v, position, id);

		ArrayList<String> phoneNumber = new ArrayList<String>();
		String[] selectString;

		//ּҷϿ ȣ 
		HayContactAdapter contactAdapter = new HayContactAdapter(getContentResolver());
		HayContact contact = contactAdapter.getContact(cateList.get(position).getContact_id());

		if(contact != null){
			selectString = new String[] { "Call", "SMS", " " };
			if(contact.isHasPhone()){
				for(int i =0 ; i < contact.getPhone_type().size() ; i++){
					phoneNumber.add(contact.getPhone_number().get(i));                  
				}
				// ȣ Ƶд.
				selectNumber = new String[phoneNumber.size()];
				for(int i=0;i<phoneNumber.size();i++){
					selectNumber[i] = phoneNumber.get(i);
				}

			}
		}
		else{
			//ּҷϿ   ̴.
			selectString = new String[] { "Call", "SMS", "ּҷ߰ " };
		}


		//,ȭ,󼼺 ,
		new AlertDialog.Builder(this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int what) {
				switch (what) {
				case 0:// ȭκ

					if(selectNumber.length>1){
						//ȭȣ 
						new AlertDialog.Builder(ListFew.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[which]));
								startActivity(i);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[0]));
						startActivity(i);
					}
					break;

				case 1: // ںκ
					if(selectNumber.length>1){
						//ȭȣ
						new AlertDialog.Builder(ListFew.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i2 = new Intent(ListFew.this,HaySmsDetail.class);
								i2.putExtra("contact_number",selectNumber[which]);
								startActivity(i2);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i2 = new Intent(ListFew.this,HaySmsDetail.class);
						i2.putExtra("contact_number",selectNumber[0]);
						startActivity(i2);
					}
					break;

				case 2: // 
					if(cateList.get(position).getContact_id() == -1){
						AlertDialog.Builder alert = new AlertDialog.Builder(ListFew.this);
						alert.setIcon(R.drawable.icon);
						alert.setTitle(cateList.get(position).getNumber()+" ߰Ͻðڽϱ?");
						alert.setPositiveButton("Ȯ", 
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								// ּҷ  θ. 
								Intent intent = new Intent(Intent.ACTION_INSERT,ContactsContract.Contacts.CONTENT_URI); 
								intent.putExtra("phone", cateList.get(position).getName()); 
								startActivity(Intent.createChooser(intent, "Select Contact"));
							}
						});
						alert.setNegativeButton("", null	);
						AlertDialog ad = alert.create();
						ad.show();
					}
					else{
						Intent intent = new Intent(ListFew.this, HayDetail.class);
						intent.putExtra("contact_id", cateList.get(position).getContact_id());
						startActivity(intent);
					}

					break;
				}
			}
		}).setNegativeButton("", null).show();
	}

	private class ListAdapter extends ArrayAdapter<HayCallLog> {

		private ArrayList<HayCallLog> items;

		public ListAdapter(ArrayList<HayCallLog> items) {
			super(ListFew.this, 0, items);
			this.items = items;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;

			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.list_content, null);
			}

			HayCallLog calllog = items.get(position);

			if (calllog != null) {
				TextView name = (TextView) v.findViewById(R.list_content.name);
				TextView number = (TextView) v.findViewById(R.list_content.number);

				ImageView state = (ImageView) v.findViewById(R.list_content.state);
				ImageView image = (ImageView) v.findViewById(R.list_content.image);

				int score = calllog.getScore();
				if(score<20) image.setImageResource(R.drawable.state1);
				else if(score<60) image.setImageResource(R.drawable.state2);
				else if(score<200) image.setImageResource(R.drawable.state3);
				else if(score<400) image.setImageResource(R.drawable.state4);
				else image.setImageResource(R.drawable.state5);

				HayContactAdapter contactAdapter = new HayContactAdapter(getContentResolver());
				
				// ͺ.
				Bitmap bmp = calllog.getPicture();
				
				//  ;
				if(bmp==null){
					
					// ´.
					bmp = contactAdapter.loadContactPhoto(calllog.getContact_id());
					
					//û ;;;
					if(bmp != null){
						BitmapFactory.Options bo = new BitmapFactory.Options();
						bo.inSampleSize = 8;
						bmp = Bitmap.createScaledBitmap(bmp, 65, 65, true);
						
					}
					else{
						bmp= BitmapFactory.decodeResource(v.getResources(),R.drawable.contact_picture );
					}
					
					calllog.setPicture(bmp);
				}
				
				state.setImageBitmap(bmp);
				

				//ּҷϿ ȣ 
				int contact_id = calllog.getContact_id();
				if(calllog.getName().equals("")){
					HayContact contact = contactAdapter.getContact(contact_id);
					if(contact != null){
						calllog.setName(contact.getDisplay_name());
						String contact_number="";
						if(contact.isHasPhone()){
							for(int i =0 ; i < contact.getPhone_type().size() ; i++){
								contact_number += ''+contact.getPhone_type().get(i)+"\n"+contact.getPhone_number().get(i)+"\n";
							}
						}
						calllog.setNumber(contact_number);
					}
					else{
						mDbHelper.open();
						mDbHelper.deleteAddition(contact_id);
						mDbHelper.close();
					}
				}

				name.setText(calllog.getName());
				number.setText(calllog.getNumber());
				calllog.getScore();
			}
			return v;
		}
	}
}
